/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HubspotConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HubspotConnectorFormAllOf{}

// HubspotConnectorFormAllOf struct for HubspotConnectorFormAllOf
type HubspotConnectorFormAllOf struct {
	// Source label
	Label *string `json:"label,omitempty"`
	// OAuth ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Object to be queried
	Object *string `json:"object,omitempty"`
	// List of selected fields
	Property []string `json:"property,omitempty"`
	// Final selections of the attributes to be included in the source
	Attributes []string `json:"attributes,omitempty"`
}

// NewHubspotConnectorFormAllOf instantiates a new HubspotConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHubspotConnectorFormAllOf() *HubspotConnectorFormAllOf {
	this := HubspotConnectorFormAllOf{}
	return &this
}

// NewHubspotConnectorFormAllOfWithDefaults instantiates a new HubspotConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHubspotConnectorFormAllOfWithDefaults() *HubspotConnectorFormAllOf {
	this := HubspotConnectorFormAllOf{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *HubspotConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *HubspotConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *HubspotConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *HubspotConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *HubspotConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *HubspotConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetObject returns the Object field value if set, zero value otherwise.
func (o *HubspotConnectorFormAllOf) GetObject() string {
	if o == nil || IsNil(o.Object) {
		var ret string
		return ret
	}
	return *o.Object
}

// GetObjectOk returns a tuple with the Object field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorFormAllOf) GetObjectOk() (*string, bool) {
	if o == nil || IsNil(o.Object) {
		return nil, false
	}
	return o.Object, true
}

// HasObject returns a boolean if a field has been set.
func (o *HubspotConnectorFormAllOf) HasObject() bool {
	if o != nil && !IsNil(o.Object) {
		return true
	}

	return false
}

// SetObject gets a reference to the given string and assigns it to the Object field.
func (o *HubspotConnectorFormAllOf) SetObject(v string) {
	o.Object = &v
}

// GetProperty returns the Property field value if set, zero value otherwise.
func (o *HubspotConnectorFormAllOf) GetProperty() []string {
	if o == nil || IsNil(o.Property) {
		var ret []string
		return ret
	}
	return o.Property
}

// GetPropertyOk returns a tuple with the Property field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorFormAllOf) GetPropertyOk() ([]string, bool) {
	if o == nil || IsNil(o.Property) {
		return nil, false
	}
	return o.Property, true
}

// HasProperty returns a boolean if a field has been set.
func (o *HubspotConnectorFormAllOf) HasProperty() bool {
	if o != nil && !IsNil(o.Property) {
		return true
	}

	return false
}

// SetProperty gets a reference to the given []string and assigns it to the Property field.
func (o *HubspotConnectorFormAllOf) SetProperty(v []string) {
	o.Property = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *HubspotConnectorFormAllOf) GetAttributes() []string {
	if o == nil || IsNil(o.Attributes) {
		var ret []string
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorFormAllOf) GetAttributesOk() ([]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *HubspotConnectorFormAllOf) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given []string and assigns it to the Attributes field.
func (o *HubspotConnectorFormAllOf) SetAttributes(v []string) {
	o.Attributes = v
}

func (o HubspotConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HubspotConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Object) {
		toSerialize["object"] = o.Object
	}
	if !IsNil(o.Property) {
		toSerialize["property"] = o.Property
	}
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	return toSerialize, nil
}

type NullableHubspotConnectorFormAllOf struct {
	value *HubspotConnectorFormAllOf
	isSet bool
}

func (v NullableHubspotConnectorFormAllOf) Get() *HubspotConnectorFormAllOf {
	return v.value
}

func (v *NullableHubspotConnectorFormAllOf) Set(val *HubspotConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableHubspotConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableHubspotConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHubspotConnectorFormAllOf(val *HubspotConnectorFormAllOf) *NullableHubspotConnectorFormAllOf {
	return &NullableHubspotConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableHubspotConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHubspotConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
